function Au = ApplyAdvection(u,params);
% apply advection matrix with spline interpolation
% to the ghost
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%global tau h x m gam

tau = params{1};
h = params{2};
x = params{3};
m = params{4};
gam = params{5};

% initialise
Au = zeros(m,1);

Au(1) = u(1);

% Au      = u + gamma*(u_{i+1}-u{i-1});
Au(2:m-1) = u(2:m-1) + gam*(u(3:m)-u(1:m-2));

% last row
spline_nodes = x; %x([m-3,m-2,m-1,m]);
spline_vals  = u; %u([m-3,m-2,m-1,m]);
u_ghost = spline(spline_nodes,spline_vals,x(m)+h);

%u_ghost = u(m);

Au(m) = u(m) + gam*(u_ghost - u(m-1));