% script file advection.m
% solve 
% du/dt + du/dx = 0
% u(t,0) = sin(t)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc; clear all;

%global tau h x m gam

m = 100; % number of space steps
x = linspace(0,1,m)';

h = x(2)-x(1);

tau = h; % time step

gam = tau/2/h;

time_steps = 500; % how many time steps to be done

% initialise
u=0*sin(2*pi*x);
figure(1)
clf
plot(x,u);

tol = 1e-3;
maxit = 500;

ApplyAdvectionParams = {tau,h,x,m,gam};

for n=1:time_steps
  % the corresponding rhs
  t = n*tau;
  b = [sin(4*pi*t); u(2:end)];

  x0 = u;
    
  u = GmresFcn('ApplyAdvection',b,tol,maxit,x0,ApplyAdvectionParams);

  u_ex = exactAdvection(t,x);
    
  plot(x,u,'b',x,u_ex,'r');
  axis([0 1 -1 1])
  drawnow;
end